<%@LANGUAGE="VBSCRIPT" CODEPAGE="1252"%>
<%
'__________________________________________________________________________________________
'\                                                                                         \
' \                                    SamChat v1.2                                         \
'  \_________________________________________________________________________________________\
' 
' This is the web server script.
' 
' Requirements:
' Any webserver that supports ASP and MS Access databases.
' 
'   /Krazz (krazz@semperfi.se)
'____________________________________________________________________________________________

'-------------------------------------- CONFIGURATION ---------------------------------------

' Enter where the database is located relative to your web root. If your website is located
' at for example "D:\web stuff\wwwroot\html\" and you have your database files in 
' "D:\web stuff\wwwroot\databases\" this setting should be "..\databases\samchat.mdb".
Const Database_Path = "..\databases\samchat.mdb"


' This setting enables you to clear out the database every so often. You don't have to
' worry, the database will always contain the last 200 entries. The maximum number of lines
' you can retreive is still only 20.
' Set to "True" if you want the database cleared automatically (this is the default setting).
' Set to "False" if you never want the database cleared.
Const Clean_Database = True

'---------------------------------- END OF CONFIGURATION ------------------------------------











































%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>Untitled Document</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
</head>

<body>
<%
Dim objConn
Dim objRs

Dim action
Dim userID
Dim password
Dim theOrder

Set objConn = CreateDbConn

' Forcing the page to update
Response.Expires = 0
Response.CacheControl = "No-cache"

action = Request.QueryString("action")
userID = CInt(Request.QueryString("user"))
password = Request.QueryString("password")
theOrder = Request.QueryString("order")

If userID <> "" And password <> "" Then
	Set objRs = objConn.execute("SELECT Count(ID) As numUsers FROM users WHERE ID = " & userID & " AND password = '" & password & "'")
		If Not objRs.EOF Then
			numUsers = objRs("numUsers")
		End If
	objRs.Close()
End If

If numUsers > 0 Then
	If action = "showLog" Then
		Call createLog()
	ElseIf action = "addLine" Then
		Call addLine()
	Else
		Response.Write "Empty" & vbCrLf
	End If
Else
	Response.Write "Invalid Login!"
End If

objConn.Close()

Private Sub addLine()
	Dim theMessage
	Dim ip
	Dim theDate
	
	Response.Write "Response:"
	
	theMessage = Request.QueryString("message")
	ip = Request.ServerVariables("REMOTE_ADDR")
	theDate = Now()
	
	theMessage = Replace(theMessage, "'", "''")
	theMessage = Replace(theMessage, vbCrLf, "%b")
	
	If theMessage = "" Then
		Response.Write "Error<BR>"
		Response.End()
	End If
	
	If Not IsNumeric(userID) Or userID = "" Then
		Response.Write "Error<BR>"
		Exit Sub
	End If
	
	objConn.execute("INSERT INTO messages (message, userID, ip, date_add) VALUES ('" & theMessage & "', " & userID & ", '" & ip & "', '" & theDate & "')")
	
	Response.Write "Added<BR>"
	
	If Clean_Database = True Then
		Call databaseCleanUp()
	End If
End Sub

Private Sub createLog()
	Dim ctr
	Response.Write "Chatlog:" & "<BR>" & vbCrLf
	
	ctr = 0
	Set objRs = objConn.execute("SELECT TOP 20 message, (SELECT username FROM users WHERE users.ID = messages.userID) AS theUser, date_add, ip FROM messages ORDER BY date_add " & theOrder)
		If Not objRs.EOF Then
			Do While Not objRs.EOF
				Response.Write objRs("date_add") & "||" & objRs("theUser") & "||" & objRs("message") & "||" & objRs("ip") & "<BR>" & vbCrLf
				ctr = ctr + 1
				objRs.MoveNext
			Loop
		Else
			Response.Write "Empty" & vbCrLf
		End If
	objRs.Close()
	
	Response.Write "-EOF-" & ctr
End Sub

Private Sub databaseCleanUp()
	' Cleans up the database so there is a maximum of 200 entries in the database.
	' The cleanup only runs if there is more than 500 rows in the database.
	
	Set objRs = objConn.execute("SELECT Count(*) As numRows FROM messages")
		numRows = objRs("numRows")
	objRs.Close()
	
	If numRows > 500 Then
		objConn.execute("SELECT TOP 200 * INTO messages2 FROM messages ORDER BY date_add DESC")
		objConn.execute("DELETE * FROM messages")
		objConn.execute("INSERT INTO messages (message, userID, ip, date_add) SELECT message, userID, ip, date_add FROM messages2 ORDER BY date_add ASC")
		objConn.execute("DROP TABLE messages2")
		
		objConn.execute("INSERT INTO messages (message, userID, ip, date_add) VALUES ('Database cleaned (300 rows removed)', 1, '0.0.0.0', " & Now() & ")")
		Response.Write "Database Cleaned"
	End If
End Sub

Private Function CreateDBConn()
	Set objConn = Server.CreateObject("ADODB.Connection")
	objConn.ConnectionTimeout = 15
	objConn.CommandTimeout = 30
	objConn.CursorLocation = 3
	objConn.Open "DRIVER={Microsoft Access Driver (*.mdb)};PWD=;DBQ=" & Request.ServerVariables("APPL_PHYSICAL_PATH") & Database_Path & ";" 
	Set CreateDBConn = objConn
End Function
%>
</body>
</html>
